/**
 * asynchronous report class
 * 
 * @author Jangot
 * 
 * @param url for request (should be a picture)
 * 
 */
function adhandsReport(url) {
    this.url = url?url:'http://sedu.adhands.ru/site/';
    this.dataType = 'string';

    /**
	 * stores data for request
	 */
    this.storedData = new Object();

    /**
	 * function for data call without parameters, it return data object call
	 * with "name" return value this name call width "name" & "value" set with
	 * value
	 */
    this.data = function (name, value) {
        if (arguments.length == 0) {
            return this.getData();
        } else if (arguments.length == 1) {
            return this.storedData[name];
        } else {
            this.storedData[name] = value;
        }
    }

    /**
	 * @return data
	 */
    this.getData = function () {
        var string = '';
        switch (this.dataType) {
            case 'string':
                var ref = '';
                for (name in this.storedData) {
                    if (name == 'ref') {
                        ref = this.storedData[name];
                        continue;
                    }
                    string += (name + '=' + this.storedData[name] + '&');
                }
                if (ref != '') {
                    string += ('ref=' + ref + '&');
                }
                string = string.substring(0, string.length - 1);
                break;
            case 'JSON':
                var string = '{';
                var ref = '';
                for (name in this.storedData) {
                    if (name == 'ref') {
                        ref = this.storedData[name];
                        continue;
                    }
                    string += ('"' + name + '"' + ':' + '"' + this.storedData[name]) + '"' + ',';
                }
                if (ref != '') {
                    string += ('"ref":"' + ref + '",');
                }
                string = string.substring(0, string.length - 1) + '}';
                break;
        }
        return string;
    }


    /**
	 * send data to server
	 */
    this.send = function () {
        var img = document.createElement('img');
        var data = this.getData();
        img.src = this.url + '?' + data;
    }

    /**
	 * set id in storedData
	 */
    this.id = function (value) {
        this.data('clid', value);
    }

    /**
	 * save location
	 */
    this.data('ref', window.location);
}

