/*!
 * WebTrends MailTo Plugin v1.0.0
 * Copyright (c) 2012 Unic AG
 * Author: julian.wachholz@unic.com
 *
 * Readding functionality to WebTrends analytics
 */
(function(w, d) {
	if(!w.Webtrends) {
		return;
	}

	var WTMailTo = {
		plugMap: {},

		/**
		 * Callback for click events, should track all mailto: links
		 */
		clickEvent: function (tag, o_evt) {
			var tagObj, e, trackOptions, mail;

			tagObj = WTMailTo.plugMap[tag.dcssID];
			if (!tagObj) {
				return;
			}

			e = o_evt.event || w.event;

			if (!!e.target && e.target.hasAttribute('href') && /^mailto:/i.test(e.target.href)) {
				if (!tagObj.mTrackOptions['args']) {
					tagObj.mTrackOptions['args'] = {};
				}

				mail = {};
				mail.address = e.target.href.match(/^mailto:([^\?&]*)/i);
				mail.subject = e.target.href.match(/[\?&]subject=([^&]*)/i);
				mail.body = e.target.href.match(/[\?&]body=([^&]*)/i);

				tagObj.mTrackOptions['args']['DCS.dcsuri'] = e.target.href;
				tagObj.mTrackOptions['args']['WT.ti'] = 'MailTo:' + (mail.address ? mail.address[1] : '');
				tagObj.mTrackOptions['args']['WT.dl'] = '23';
				tagObj.mTrackOptions['args']['WT.i_mailto_address'] = mail.address ? mail.address[1] : '';
				//tagObj.mTrackOptions['args']['WT.i_mailto_subject'] = mail.subject ? mail.subject[1] : '';
				//tagObj.mTrackOptions['args']['WT.i_mailto_body'] = mail.body ? mail.body[1] : '';
				//tagObj.mTrackOptions['args']['WT.i_mailto_tv'] = '0.0.0';

				tagObj.dcsMultiTrack(tagObj.mTrackOptions);
			}
		},

		/**
		 * Register function called when the main tag is ready for collection
		 *
		 * @param   {Object} tag    Description
		 * @param   {Object} plugin Description
		 */
		register: function (tag, plugin) {
			if (plugin['filter'] && plugin['filter']())
				return;

			var tagObj = new Webtrends.dcs();

			// I have no idea what these variables do
			tagObj.init({
				dcsid  : ((plugin['dcsid']) ? plugin['dcsid'] : tag['dcsid']),
				fpc: tag['fpc'],
				fpcdom: tag['fpcdom'],
				timezone: tag['timezone'],
				i18n: tag['i18n'],
				vtid: tag['vtid'],
				cookieexpires: tag['cookieExp'],
				enabled: tag['enabled'],
				privateFlag : true
			});

			WTMailTo.plugMap[tag.dcssID] = tagObj;
			Webtrends.bindEvent('wtmouseup', WTMailTo.clickEvent, tag);

			if (plugin["mTrackOptions"]) {
				tagObj.mTrackOptions = plugin["mTrackOptions"];
			} else {
				tagObj.mTrackOptions = {};
			}
		}
	};

	w.WebtrendsMailTo = WTMailTo;
	Webtrends.registerPlugin('mailto', WTMailTo.register);

})(window, document);